function [L, U] = lu2( A )
%LU   LU-factorization of A

	n = size(A, 1);
	L = eye(n);
	U = A;
	
	% Transform A into upper triangular form
	for k = 1:n
		% Zero column?
		if all(abs(A(k:n, k)) < eps)
			% A is singular; return "false"
			L = false;
			U = false;
			return;
		end
		
		% Set the k-th column of L
		L(k+1:n,k) = U(k+1:n,k) / U(k,k);
		U(k+1:n,k:n) = U(k+1:n,k:n) - U(k+1:n,k) * U(k,k:n) / U(k,k); 
	end
end